	// verilator_coverage annotation
	// generated by verigenSV.pl on Fri Apr 23 15:00:13 2021
	// input file: mesi.cfg
	
	// compiler directives
	/* verilator lint_off CASEINCOMPLETE */
	/* verilator lint_off DECLFILENAME */
	/* verilator lint_off UNUSED */
	/* verilator lint_off STMTDLY */
	/* verilator lint_off UNOPTFLAT */
	
	module MESI (
 000200		input logic clk,
%000003		input logic res_n,
%000017		input logic [31:0] addr,
 000019		input logic cp,
 000019		input logic rd,
 000022		input logic wr,
 000035		output logic [3:0] mesi, 
%000008		output logic [5:0] index, 
 000010		output logic err, 
%000008		output logic TAG_RAM_status, 
 000034		output logic MESI_RAM_status );
	
	  //
	 // parameter constants 
	//---------------------------
	parameter ZERO = 1'b0;
	parameter ONE = 1'b1;
	parameter ZERO_MESI = 4'b0000;
	parameter ZERO_TAG = 24'h000000;
	parameter ZERO_ADDR = 6'b000000;
	parameter MODIFIED = 4'b1000;
	parameter EXCLUSIVE = 4'b0100;
	parameter SHARED = 4'b0010;
	parameter INVALID = 4'b0001;
	
	
	  //
	 // state encoding typedef 
	//--------------------------------
	typedef enum logic [2:0] {
		ID	 = 3'b000,
		RD	 = 3'b001,
		WR	 = 3'b010,
		rRD	 = 3'b101,
		rWR	 = 3'b110
	} states_t;
	
	
	// internal state variables
 000051	states_t STATE, NEXT_STATE;
 000051	verilator_coverage: (next point on previous line)

	
	
	  //
	 // memory instantiations 
	//---------------------------
 000200	logic MESI_RAM_clk; 
%000003	logic MESI_RAM_res_n; 
 000035	logic MESI_RAM_wr;
%000009	logic [5:0] MESI_RAM_wr_addr;
 000036	logic [3:0] MESI_RAM_wr_data;
 000027	logic MESI_RAM_rd;
%000008	logic [5:0] MESI_RAM_rd_addr;
 000054	logic [3:0] MESI_RAM_rd_data;
	assign MESI_RAM_clk = clk;
	assign MESI_RAM_res_n = res_n;
	RAM #(4,64) MESI_RAM(.clk(MESI_RAM_clk), .res_n(MESI_RAM_res_n), 
		.wr(MESI_RAM_wr), .wr_addr(MESI_RAM_wr_addr[5:0]), .wr_data(MESI_RAM_wr_data[3:0]), 
		.rd(MESI_RAM_rd), .rd_addr(MESI_RAM_rd_addr[5:0]), .rd_data(MESI_RAM_rd_data[3:0]) );
	
 000200	logic TAG_RAM_clk; 
%000003	logic TAG_RAM_res_n; 
%000008	logic TAG_RAM_wr;
%000008	logic [5:0] TAG_RAM_wr_addr;
%000031	logic [23:0] TAG_RAM_wr_data;
 000038	logic TAG_RAM_rd;
%000008	logic [5:0] TAG_RAM_rd_addr;
 000275	logic [23:0] TAG_RAM_rd_data;
	assign TAG_RAM_clk = clk;
	assign TAG_RAM_res_n = res_n;
	RAM #(24,64) TAG_RAM(.clk(TAG_RAM_clk), .res_n(TAG_RAM_res_n), 
		.wr(TAG_RAM_wr), .wr_addr(TAG_RAM_wr_addr[5:0]), .wr_data(TAG_RAM_wr_data[23:0]), 
		.rd(TAG_RAM_rd), .rd_addr(TAG_RAM_rd_addr[5:0]), .rd_data(TAG_RAM_rd_data[23:0]) );
	
	
	  //
	 // implicit continuous assignments 
	//----------------------------------
 000039	wire IDLE; assign IDLE = ~res_n | (~rd & ~wr);
%000009	wire IS_EXCLUSIVE; assign IS_EXCLUSIVE = READ_MESI_RAM(MESI_READ,addr[7:2])==EXCLUSIVE;
 000019	wire IS_INVALID; assign IS_INVALID = READ_MESI_RAM(MESI_READ,addr[7:2])==INVALID;
 000019	wire IS_MODIFIED; assign IS_MODIFIED = READ_MESI_RAM(MESI_READ,addr[7:2])==MODIFIED;
%000009	wire IS_SHARED; assign IS_SHARED = READ_MESI_RAM(MESI_READ,addr[7:2])==SHARED;
 000027	wire MESI_READ; assign MESI_READ = WRITE | (TAG_MATCH & (rREAD | rWRITE));
 000035	wire MESI_WRITE; assign MESI_WRITE = READ | WRITE | (TAG_MATCH & (rREAD | rWRITE));
%000009	wire READ; assign READ = res_n & cp & rd;
 000035	wire TAG_MATCH; assign TAG_MATCH = READ_TAG_RAM(TAG_READ,addr[7:2])==addr[31:8];
 000039	wire TAG_READ; assign TAG_READ = READ | WRITE | rREAD | rWRITE;
%000008	wire TAG_WRITE; assign TAG_WRITE = !TAG_MATCH & READ;
 000010	wire WRITE; assign WRITE = res_n & cp & wr;
 000010	wire rREAD; assign rREAD = res_n & ~cp & rd;
 000010	wire rWRITE; assign rWRITE = res_n & ~cp & wr;
	
	
	  //
	 // initials for simulator
	//---------------------------
%000002	initial begin
%000001		STATE = ID;
%000001		MESI_RAM_wr = 1'b0;
%000001		MESI_RAM_wr_addr = {6{1'b0}};
%000001		MESI_RAM_wr_data = {4{1'b0}};
%000001		MESI_RAM_rd = 1'b0;
%000001		MESI_RAM_rd_addr = {6{1'b0}};
%000001		TAG_RAM_wr = 1'b0;
%000001		TAG_RAM_wr_addr = {6{1'b0}};
%000001		TAG_RAM_wr_data = {24{1'b0}};
%000001		TAG_RAM_rd = 1'b0;
%000001		TAG_RAM_rd_addr = {6{1'b0}};
	
	  // dump output (Verilator)
%000002	  if ($test$plusargs("trace") != 0) begin
%000000	  verilator_coverage: (next point on previous line)

%000001	    $display("[%0t] Tracing to logs/vlt_dump.vcd...\n", $time);
%000001	    $dumpfile("logs/vlt_dump.vcd");
%000001	    $dumpvars();
	  end
%000001	  $display("[%0t] Model running...\n", $time);
	
	
	end
	
	
	  //
	 // state transfer
	//---------------------------
 000202	always_ff @(posedge clk or negedge res_n) begin
%000006	  if( !res_n )
 000098	  verilator_coverage: (next point on previous line)

%000003	    STATE <= ID;
	  else
 000098	    STATE <= NEXT_STATE;
	
	  // condition for $finish (Verilator)
%000002	  if( rd==1'b1 && wr==1'b1 ) begin
 000100	  verilator_coverage: (next point on previous line)

%000001	    $write("*-* All Finished *-*\n");
%000001	    $finish;
	  end   
	
	end
	// AssertionExample:
	//always_ff @ (posedge clk) begin
	//   AssertionExample: assert (rd==1'b1 ^ wr==1'b1);
	//end
	
	// coverage analysis (Verilator)
%000000	cover property (@(posedge clk) rd==1'b1 && wr==1'b1);
	
 000530	always_comb begin
 000265	  unique case ( STATE )
 000398	  ID : begin
		// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
 000302		if ( IDLE ) begin
 000048		verilator_coverage: (next point on previous line)

 000151		  NEXT_STATE = ID;
		  // MEMORY action ...
 000151		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
 000151		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
 000151		  err=ZERO;
 000151		  mesi=ZERO_MESI;
 000151		  index=addr[7:2];
		end
%000004		if ( READ & TAG_MATCH ) begin
 000197		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = RD;
		  // MEMORY action ...
%000002		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000002		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
		  // MEALY output action ...
%000002		  err=ZERO;
%000002		  mesi=EXCLUSIVE;
%000002		  index=addr[7:2];
		end
%000012		if ( READ & ~TAG_MATCH ) begin
 000193		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = RD;
		  // MEMORY action ...
%000006		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
%000006		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
		  // MEALY output action ...
%000006		  err=ZERO;
%000006		  mesi=EXCLUSIVE;
%000006		  index=addr[7:2];
		end
%000010		if ( WRITE & TAG_MATCH ) begin
 000194		verilator_coverage: (next point on previous line)

%000005		  NEXT_STATE = WR;
		  // MEMORY action ...
%000005		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000005		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],MODIFIED);
		  // MEALY output action ...
%000005		  err=ZERO;
%000005		  mesi=MODIFIED;
%000005		  index=addr[7:2];
		end
%000010		if ( WRITE & ~TAG_MATCH ) begin
 000194		verilator_coverage: (next point on previous line)

%000005		  NEXT_STATE = WR;
		  // MEMORY action ...
%000005		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000005		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
%000005		  err=ONE;
%000005		  mesi=ZERO_MESI;
%000005		  index=addr[7:2];
		end
 000020		if ( rWRITE & TAG_MATCH ) begin
 000189		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = rWR;
		  // MEMORY action ...
 000010		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
 000010		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],INVALID);
		  // MEALY output action ...
 000010		  err=ZERO;
 000010		  mesi=INVALID;
 000010		  index=addr[7:2];
		end
%000012		if ( rREAD & TAG_MATCH ) begin
 000193		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = rRD;
		  // MEMORY action ...
%000006		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000006		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
		  // MEALY output action ...
%000006		  err=ZERO;
%000006		  mesi=SHARED;
%000006		  index=addr[7:2];
		end
%000018		if ( rREAD & ~TAG_MATCH ) begin
 000190		verilator_coverage: (next point on previous line)

%000009		  NEXT_STATE = ID;
		  // MEMORY action ...
%000009		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000009		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
%000009		  err=ZERO;
%000009		  mesi=ZERO_MESI;
%000009		  index=addr[7:2];
		end
	  end // ID
 000028	  RD : begin
		// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
%000016		if ( IDLE ) begin
%000006		verilator_coverage: (next point on previous line)

%000008		  NEXT_STATE = ID;
		  // MEMORY action ...
%000008		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000008		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
%000008		  err=ZERO;
%000008		  mesi=ZERO_MESI;
%000008		  index=addr[7:2];
		end
%000008		if ( READ & TAG_MATCH ) begin
 000010		verilator_coverage: (next point on previous line)

%000004		  NEXT_STATE = RD;
		  // MEMORY action ...
%000004		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000004		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
		  // MEALY output action ...
%000004		  err=ZERO;
%000004		  mesi=EXCLUSIVE;
%000004		  index=addr[7:2];
		end
%000004		if ( READ & ~TAG_MATCH ) begin
 000012		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = RD;
		  // MEMORY action ...
%000002		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
%000002		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
		  // MEALY output action ...
%000002		  err=ZERO;
%000002		  mesi=EXCLUSIVE;
%000002		  index=addr[7:2];
		end
	  end // RD
 000040	  WR : begin
		// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
 000020		if ( IDLE ) begin
 000010		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = ID;
		  // MEMORY action ...
 000010		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
 000010		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
 000010		  err=ZERO;
 000010		  mesi=ZERO_MESI;
 000010		  index=addr[7:2];
		end
 000020		if ( WRITE & TAG_MATCH ) begin
 000010		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = WR;
		  // MEMORY action ...
 000010		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
 000010		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],MODIFIED);
		  // MEALY output action ...
 000010		  err=ZERO;
 000010		  mesi=MODIFIED;
 000010		  index=addr[7:2];
		end
%000000		if ( WRITE & ~TAG_MATCH ) begin
 000020		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = ID;
		  // MEMORY action ...
%000000		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000000		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
%000000		  err=ONE;
%000000		  mesi=ZERO_MESI;
%000000		  index=addr[7:2];
		end
	  end // WR
 000024	  rRD : begin
		// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
%000012		if ( IDLE ) begin
%000006		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = ID;
		  // MEMORY action ...
%000006		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000006		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
%000006		  err=ZERO;
%000006		  mesi=ZERO_MESI;
%000006		  index=addr[7:2];
		end
%000012		if ( rREAD & TAG_MATCH ) begin
%000006		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = rRD;
		  // MEMORY action ...
%000006		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000006		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
		  // MEALY output action ...
%000006		  err=ZERO;
%000006		  mesi=SHARED;
%000006		  index=addr[7:2];
		end
%000000		if ( rREAD & ~TAG_MATCH ) begin
 000012		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = rRD;
		  // MEMORY action ...
%000000		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
%000000		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
		  // MEALY output action ...
%000000		  err=ZERO;
%000000		  mesi=SHARED;
%000000		  index=addr[7:2];
		end
	  end // rRD
 000040	  rWR : begin
		// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
 000020		if ( IDLE ) begin
 000010		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = ID;
		  // MEMORY action ...
 000010		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
 000010		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
 000010		  err=ZERO;
 000010		  mesi=ZERO_MESI;
 000010		  index=addr[7:2];
		end
 000020		if ( rWRITE & TAG_MATCH ) begin
 000010		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = rWR;
		  // MEMORY action ...
 000010		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
 000010		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],INVALID);
		  // MEALY output action ...
 000010		  err=ZERO;
 000010		  mesi=INVALID;
 000010		  index=addr[7:2];
		end
%000000		if ( rWRITE & ~TAG_MATCH ) begin
 000020		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = rWR;
		  // MEMORY action ...
%000000		  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
%000000		  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
		  // MEALY output action ...
%000000		  err=ZERO;
%000000		  mesi=ZERO_MESI;
%000000		  index=addr[7:2];
		end
	  end // rWR
	  endcase
	end // always_comb
	
	
	  //
	 // memory functions
	//---------------------------
 002120	function automatic [3:0] READ_MESI_RAM( read, [5:0] read_addr);
 001060	   MESI_RAM_rd = read;
 001060	   MESI_RAM_rd_addr = read_addr;
 001060	   READ_MESI_RAM = MESI_RAM_rd_data;
	endfunction
	
 000520	function automatic WRITE_MESI_RAM( write, [5:0] write_addr, [3:0] write_data);
 000260	   MESI_RAM_wr = write;
 000260	   MESI_RAM_wr_addr = write_addr;
 000260	   MESI_RAM_wr_data = write_data;
 000260	   WRITE_MESI_RAM = write;
	endfunction
	
 000530	function automatic [23:0] READ_TAG_RAM( read, [5:0] read_addr);
 000265	   TAG_RAM_rd = read;
 000265	   TAG_RAM_rd_addr = read_addr;
 000265	   READ_TAG_RAM = TAG_RAM_rd_data;
	endfunction
	
 000520	function automatic WRITE_TAG_RAM( write, [5:0] write_addr, [23:0] write_data);
 000260	   TAG_RAM_wr = write;
 000260	   TAG_RAM_wr_addr = write_addr;
 000260	   TAG_RAM_wr_data = write_data;
 000260	   WRITE_TAG_RAM = write;
	endfunction
	
	endmodule
	
	
	  //
	 // memory
	//---------------------------
	module RAM ( clk, res_n, wr, wr_addr, wr_data, rd, rd_addr, rd_data );
	
	parameter data_width = 32;
	parameter entries = 16;
	parameter addr_width = $clog2(entries);
	
 000400	input  wire clk, res_n, rd, wr;
%000006	verilator_coverage: (next point on previous line)

 000065	verilator_coverage: (next point on previous line)

 000043	verilator_coverage: (next point on previous line)

 000067	input  wire [data_width-1:0] wr_data;
%000016	input  wire [addr_width-1:0] rd_addr, wr_addr;
%000017	verilator_coverage: (next point on previous line)

 000329	output wire [data_width-1:0] rd_data;
	
	parameter ZERO_ADDR = {addr_width{1'b0}};
	parameter ZERO_DATA = {data_width{1'b0}};
	parameter ONE_DATA = {data_width{1'b1}};
	    
%000163	logic    [data_width-1:0] MEMORY [entries-1:0];
	
	integer i;
	
%000004	initial begin
	   // Clear RAM before simulation start
%000002	   for ( i = 0; i < entries; i = i + 1 ) begin
 000256	   verilator_coverage: (next point on previous line)

 000128	       MEMORY[ i ] = ONE_DATA;
	   end
	end
	
	// IN-CYCLE READ ACCESS
	assign rd_data =  ( rd ) ? MEMORY[rd_addr] : 'Z;
	
 000396	always @ ( posedge clk ) begin
	    // WRITE ACCESS
 000038	   if( wr ) MEMORY[wr_addr] <= wr_data;
 000179	   verilator_coverage: (next point on previous line)

	end
	
	endmodule
	
